com.io7m.jcanephora.jogl

## Interface JCGLImplementationJOGLType

- All Superinterfaces:
    JCGLImplementationType
  All Known Implementing Classes:
    JCGLImplementationJOGL

      public interface JCGLImplementationJOGLType
      extends JCGLImplementationType

  JOGL-specific interface to JCGL implementations.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `JCGLContextType` | `newContextFrom(com.jogamp.opengl.GLContext c, String name)` Construct a new context from the given `GLContext`.
    `JCGLContextType` | `newContextFromWithSupplier(com.jogamp.opengl.GLContext c, Function<com.jogamp.opengl.GLContext,com.jogamp.opengl.GL3> gl_supplier, String name)` Construct a new context from the given `GLContext`.

- - ### Method Detail

    - #### newContextFrom

          JCGLContextType newContextFrom(com.jogamp.opengl.GLContext c,
                                         String name)
                                  throws JCGLException,
                                         JCGLExceptionUnsupported,
                                         JCGLExceptionNonCompliant

      Construct a new context from the given `GLContext`.
      Parameters:
        `c` - An existing context
        `name` - The name assigned to the context, for debugging purposes
      Returns:
        A new context
      Throws:
        `JCGLException` - On errors
        `JCGLExceptionUnsupported` - If the context is of a version that is not supported
        `JCGLExceptionNonCompliant` - If the context violates the OpenGL specification

    - #### newContextFromWithSupplier

          JCGLContextType newContextFromWithSupplier(com.jogamp.opengl.GLContext c,
                                                     Function<com.jogamp.opengl.GLContext,com.jogamp.opengl.GL3> gl_supplier,
                                                     String name)
                                              throws JCGLException,
                                                     JCGLExceptionUnsupported,
                                                     JCGLExceptionNonCompliant

      Construct a new context from the given `GLContext`. The function `gl_supplier` will be evaluated at least once to supply a `GL3` instance to the implementation. This allows for the substitution of alternate `GL3` instances for unit testing and debugging.
      Parameters:
        `c` - An existing context
        `gl_supplier` - A function that yields a `GL3` implementation, given a `GLContext`
        `name` - The name assigned to the context, for debugging purposes
      Returns:
        A new context
      Throws:
        `JCGLException` - On errors
        `JCGLExceptionUnsupported` - If the context is of a version that is not supported
        `JCGLExceptionNonCompliant` - If the context violates the OpenGL specification

Copyright © 2016 <code@io7m.com> http://io7m.com